/* RtTrend.h */

#ifndef __RT_TREND_H_INCLUDED
#define __RT_TREND_H_INCLUDED

#ifndef __PT_BASIC_H_INCLUDED
 #include <photon/PtBasic.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern PtWidgetClassRef_t *RtTrend;

typedef struct Rt_trend_attr {
	int map;
	}
		RtTrendAttr_t;


typedef struct Rt_trend_lines {
	short	 	*data;
	short int	valid_size;	
	}
		RtTrendLines_t;

typedef struct Rt_trend_widget {
	PtBasicWidget_t		basic;
	long 				flags;
	short 				grid_x;
	short 				grid_y;
	short 				trend_count;
	short 				sample_size;
	unsigned			n_data;
	short 				max;
	short 				min;
	short 				inc;
	short 				modify;
	RtTrendLines_t		*lines;
	RtTrendAttr_t		*attrs;
	PgColor_t			grid_color;
	PgColor_t			*list;
	short				tmask;
	unsigned short		pallen;
	short 				base;
	short 				grid_base;
	short 	 			color_count;
	unsigned short 		width;
	short				delta;
	unsigned short		dflag;
	PhPoint_t			origin;
	}
		RtTrendWidget_t;

/* Widget union */
typedef union Rt_trend_union {
	PtWidget_t			core;
	PtBasicWidget_t		basic;
	RtTrendWidget_t		trend;
	}
		RtTrendUnion_t;

#define Rt_ARG_TREND_DATA			Pt_RESOURCE( Pt_RTIME(1),  0 )
#define Rt_ARG_TREND_GRID_X			Pt_RESOURCE( Pt_RTIME(1),  1 )
#define Rt_ARG_TREND_GRID_Y 		Pt_RESOURCE( Pt_RTIME(1),  2 )
#define Rt_ARG_TREND_COUNT			Pt_RESOURCE( Pt_RTIME(1),  3 )
#define Rt_ARG_TREND_MAX			Pt_RESOURCE( Pt_RTIME(1),  4 )
#define Rt_ARG_TREND_MIN			Pt_RESOURCE( Pt_RTIME(1),  5 )
#define Rt_ARG_TREND_INC			Pt_RESOURCE( Pt_RTIME(1),  6 )
#define Rt_ARG_TREND_FLAGS			Pt_RESOURCE( Pt_RTIME(1),  7 )
#define Rt_ARG_TREND_GRID_COLOR		Pt_RESOURCE( Pt_RTIME(1),  8 )
#define Rt_ARG_TREND_COLOR_LIST		Pt_RESOURCE( Pt_RTIME(1),  9 )
#define Rt_ARG_TREND_ATTRIBUTES		Pt_RESOURCE( Pt_RTIME(1), 10 )
#define Rt_ARG_TREND_PALETTE_END	Pt_RESOURCE( Pt_RTIME(1), 11 )

#define Rt_PIXEL					0x00000001
#define Rt_GRID						0x00000002
#define Rt_TREND_HORIZONTAL			0x00000004
#define Rt_TREND_VERTICAL			0x00000008
#define Rt_TREND_LEFT_TO_RIGHT		0x00000010
#define Rt_TREND_RIGHT_TO_LEFT		0x00000020
#define Rt_TREND_TOP_TO_BOTTOM		0x00000040
#define Rt_TREND_BOTTOM_TO_TOP		0x00000080
#define	Rt_GRID_ABOVE_TRENDS		0x00000100
#define	Rt_TRENDS_ABOVE_GRID		0x00000200
#define Rt_GRID_IS_TRANSLUCENT		0x00000400
#define Rt_GRID_FORCE				0x00000800


extern void RtTrendPutData(
	PtWidget_t *trend, const short *newdata, int nsamples
	);

extern void RtTrendChangeData( PtWidget_t *widget,
	short const *newdata, unsigned last_sample, unsigned nsamples
	);

extern void RtTrendChangeTrendData( PtWidget_t *widget, unsigned tn,
	short const *newdata, unsigned last_sample, unsigned nsamples
	);

#ifdef __cplusplus
};
#endif
#endif
